const std = @import("std");

pub fn build(b: *std.Build) void {
	const target = b.standardTargetOptions(.{});
	const optimize = b.standardOptimizeOption(.{});
	const exe = b.addExecutable(.{
				.name = "c3d",
				.target = target,
				.optimize = optimize,
});
	exe.linkLibC();
	exe.addCSourceFiles(.{
	.files = &.{ "c3d.c", "arrayfuncs.c", "reader.c", "vecfunc.c"  }

});
	//exe.linkSystemLibrary("raylib");
	//exe.installLibraryHeaders(raylib)
	const raylib_dep = b.dependency("raylib", .{
		.target = target,
		.optimize = optimize,
		.linux_display_backend = .Wayland,
    });
	const rlib = raylib_dep.artifact("raylib");
	exe.linkLibrary(rlib);
	b.installArtifact(exe);

}
