
#ifndef C3DTYPES_HEADER
#define C3DTYPES_HEADER

#include "raylib.h"



struct LocalCam {
    Vector3 position;
    Vector3 velocity;
    Vector3 acceleration;
    Vector3 angles;
    Vector3 angleVelocity;
    Vector3 angleAcceleration;
};
typedef struct LocalCam LocalCam;

struct CMaterial {
	char * name;
	char * texturefile;
	Color * tex;
	int h;
	int w;
};
typedef struct CMaterial CMaterial;

struct Tri {
    Vector3 a;
    Vector3 b;
    Vector3 c;

    Color color;

	CMaterial * material;
	
	Vector2 auv;
	Vector2 buv;
	Vector2 cuv;
	
};


typedef struct Tri Tri;

struct Tri2D {
    Vector2 a;
    Vector2 b;
    Vector2 c;

	float adepth;
	float bdepth;
	float cdepth;

	
    Color color;


	Vector2 auv;
	Vector2 buv;
	Vector2 cuv;

	CMaterial * material;
};
typedef struct Tri2D Tri2D;

struct Zee {
    float depth;
	//Tri2D tri;
	Color c;
};
typedef struct Zee Zee;

struct TriArray {
    int length;
    Tri *arr;
};
typedef struct TriArray TriArray;

struct CMaterialArray {
	int length;
	CMaterial *arr;
};
typedef struct CMaterialArray CMaterialArray;

struct Tri2DArray {
    int length;
    Tri2D *arr;
};
typedef struct Tri2DArray Tri2DArray;

struct Object3D {
	char name[100];
	TriArray  * triangles;
	CMaterialArray *mats;
};
typedef struct Object3D Object3D;

#endif
